// FCC database access -*- C++ -*-

#include <string>
#include <iostream>
#include <sstream>
#include <fstream>

class Fm_Eng_Data {
public:
  std::string ant_input_pwr; // The input power, in dBk, of the antenna.
  std::string ant_max_pwr_gain; // The maximum amount of power gain, in dB, associated with the antenna.
  std::string ant_polarization; // Indicates the polarization properties of the proposed antenna:
  std::string ant_rotation; // The rotation, in whole degrees, associated with an FX off the shelf directional antenna
  std::string antenna_id; // Identifies a specific antenna make and model
  std::string antenna_type; // The type of the antenna in use: Directional "off the shelf";
				//Directional Composite (multiple antennas); Non-Directional
  std::string application_id; // Uniquely identifies an application.
  std::string asd_service; // The type of record, or the type of service represented by this record.FA,FM,FS,FX,FR,FB
  std::string asrn_na_ind; // ASRN Number Not Applicable Indicator
  std::string asrn; // Unique ASRN number assigned to a registered tower
  std::string avg_horiz_pwr_gain; // 
  std::string biased_lat; // Digital Latitude: Calculated value; (latitude degrees +90) + (lat_min/60) +
			  //(lat_sec/3600). Used for indexing. Eliminates negative values
  std::string biased_long; // Digital Longitude, Calculated value: (degrees+180) + (minutes/60) +
			  //(seconds/3600). Used for indexing. Eliminates negative values
  std::string border_code; // Indicates whether the coordinates are sufficiently close to an international border
  std::string border_dist; // The distance to the nearest point on the international border, in Km
  std::string docket_num; // The docket number of a hearing or rulemaking associated with this record.
  std::string effective_erp; // Effective ERP
  std::string elev_amsl; // Elevation, in meters, of site above mean sea level
  std::string elev_bldg_ag; // 
  std::string eng_record_type; // Flag indicating the type of Engineering record this is.
  std::string facility_id; // Uniquely identifies a facility.
  std::string fm_dom_status; // The domestic status of the record
  std::string gain_area; // The gain area, in square miles, resulting from the proposed changes for the 60 dbu contour.
  std::string haat_horiz_rc_mtr; // The horizontal height, in meters, of the radiation center above average terrain.
  std::string haat_vert_rc_mtr; // The radiation center above ground of the vertically polarized antenna, in meters.
  std::string hag_horiz_rc_mtr; // The radiation center above ground of the horizontally polarized antenna, in
  std::string hag_overall_mtr; // The height, in meters, of the overall antenna structure above ground.
  std::string hag_vert_rc_mtr; // The vertical height, in meters, of the radiation center above the ground.
  std::string horiz_bt_erp; // The maximum ERP, in kW, in the plane of the tilted beam, horizontal
  std::string horiz_erp; // in kw
  std::string lat_deg; // 
  std::string lat_dir; // 
  std::string lat_min; // 
  std::string lat_sec; // 
  std::string lon_deg; // 
  std::string lon_dir; // 
  std::string lon_min; // 
  std::string lon_sec; // 
  std::string loss_area; // The loss area, in square kilometers, resulting from the proposed changes for the 60 dBu contour.
  std::string max_ant_pwr_gain; // 
  std::string max_haat; // The maximum HAAT in any direction, 
  std::string max_horiz_erp; // The maximum effective radiated power, measured in kilowatts
  std::string max_vert_erp; // The maximum effective radiated power with beam tilt for a vertically polarized
  std::string multiplexor_loss; // 
  std::string power_output_vis_kw; // Visual transmitter output power in kilowatts
  std::string predict_coverage_area; // 
  std::string predict_pop; // 
  std::string rcamsl_horiz_mtr; // The height of the radiation center above mean sea level, measured in meters
  std::string rcamsl_vert_mtr; // The height of the radiation center above mean sea level for a vertically polarized
  std::string station_class; // The class of an FM station based on power and antenna height 
  std::string terrain_data_src; // 
  std::string vert_bt_erp; // The maximum ERP, in kW, in the plane of the tilted beam, vertical polarization.
  std::string vert_erp; // The effective radiated power for a vertically polarized antenna, measured in kw.
  std::string num_sections; // 
  std::string present_area; // 
  std::string percent_change; // 
  std::string spacing; // Spacing between sections (wavelegnth)
  std::string terrain_data_src_other; // 
  std::string trans_power_output; // Transmitter power output, kw
  std::string mainkey; // 
  std::string lat_whole_secs; // 
  std::string lon_whole_secs; // 
  std::string station_channel; // Station Channel
  std::string lic_ant_make; // 
  std::string lic_ant_model_num; // 
  std::string min_horiz_erp; // 
  std::string haat_horiz_calc_ind; // 
  std::string erp_w; // 
  std::string trans_power_output_w; // Transmitter power output watts
  std::string market_group_num; // 
  std::string last_change_date; // 
public: 
  Fm_Eng_Data(std::istream& in) {
    std::string buffer;
    getline(in, buffer);
    std::istringstream is(buffer);
    getline(is, ant_input_pwr, '|');
    getline(is, ant_max_pwr_gain, '|');
    getline(is, ant_polarization, '|');
    getline(is, ant_rotation, '|');
    getline(is, antenna_id, '|');
    getline(is, antenna_type, '|');
    getline(is, application_id, '|');
    getline(is, asd_service, '|');
    getline(is, asrn_na_ind, '|');
    getline(is, asrn, '|');
    getline(is, avg_horiz_pwr_gain, '|');
    getline(is, biased_lat, '|');
    getline(is, biased_long, '|');
    getline(is, border_code, '|');
    getline(is, border_dist, '|');
    getline(is, docket_num, '|');
    getline(is, effective_erp, '|');
    getline(is, elev_amsl, '|');
    getline(is, elev_bldg_ag, '|');
    getline(is, eng_record_type, '|');
    getline(is, facility_id, '|');
    getline(is, fm_dom_status, '|');
    getline(is, gain_area, '|');
    getline(is, haat_horiz_rc_mtr, '|');
    getline(is, haat_vert_rc_mtr, '|');
    getline(is, hag_horiz_rc_mtr, '|');
    getline(is, hag_overall_mtr, '|');
    getline(is, hag_vert_rc_mtr, '|');
    getline(is, horiz_bt_erp, '|');
    getline(is, horiz_erp, '|');
    getline(is, lat_deg, '|');
    getline(is, lat_dir, '|');
    getline(is, lat_min, '|');
    getline(is, lat_sec, '|');
    getline(is, lon_deg, '|');
    getline(is, lon_dir, '|');
    getline(is, lon_min, '|');
    getline(is, lon_sec, '|');
    getline(is, loss_area, '|');
    getline(is, max_ant_pwr_gain, '|');
    getline(is, max_haat, '|');
    getline(is, max_horiz_erp, '|');
    getline(is, max_vert_erp, '|');
    getline(is, multiplexor_loss, '|');
    getline(is, power_output_vis_kw, '|');
    getline(is, predict_coverage_area, '|');
    getline(is, predict_pop, '|');
    getline(is, rcamsl_horiz_mtr, '|');
    getline(is, rcamsl_vert_mtr, '|');
    getline(is, station_class, '|');
    getline(is, terrain_data_src, '|');
    getline(is, vert_bt_erp, '|');
    getline(is, vert_erp, '|');
    getline(is, num_sections, '|');
    getline(is, present_area, '|');
    getline(is, percent_change, '|');
    getline(is, spacing, '|');
    getline(is, terrain_data_src_other, '|');
    getline(is, trans_power_output, '|');
    getline(is, mainkey, '|');
    getline(is, lat_whole_secs, '|');
    getline(is, lon_whole_secs, '|');
    getline(is, station_channel, '|');
    getline(is, lic_ant_make, '|');
    getline(is, lic_ant_model_num, '|');
    getline(is, min_horiz_erp, '|');
    getline(is, haat_horiz_calc_ind, '|');
    getline(is, erp_w, '|');
    getline(is, trans_power_output_w, '|');
    getline(is, market_group_num, '|');
    getline(is, last_change_date, '|');
  }
  void dump() {
    int i = 0;
#define out(s) std::cout << ++i << ' ' << #s << "=\"" << s << "\"\n";
    out(ant_input_pwr);
    out(ant_max_pwr_gain);
    out(ant_polarization);
    out(ant_rotation);
    out(antenna_id);
    out(antenna_type);
    out(application_id);
    out(asd_service);
    out(asrn_na_ind);
    out(asrn);
    out(avg_horiz_pwr_gain);
    out(biased_lat);
    out(biased_long);
    out(border_code);
    out(border_dist);
    out(docket_num);
    out(effective_erp);
    out(elev_amsl);
    out(elev_bldg_ag);
    out(eng_record_type);
    out(facility_id);
    out(fm_dom_status);
    out(gain_area);
    out(haat_horiz_rc_mtr);
    out(haat_vert_rc_mtr);
    out(hag_horiz_rc_mtr);
    out(hag_overall_mtr);
    out(hag_vert_rc_mtr);
    out(horiz_bt_erp);
    out(horiz_erp);
    out(lat_deg);
    out(lat_dir);
    out(lat_min);
    out(lat_sec);
    out(lon_deg);
    out(lon_dir);
    out(lon_min);
    out(lon_sec);
    out(loss_area);
    out(max_ant_pwr_gain);
    out(max_haat);
    out(max_horiz_erp);
    out(max_vert_erp);
    out(multiplexor_loss);
    out(power_output_vis_kw);
    out(predict_coverage_area);
    out(predict_pop);
    out(rcamsl_horiz_mtr);
    out(rcamsl_vert_mtr);
    out(station_class);
    out(terrain_data_src);
    out(vert_bt_erp);
    out(vert_erp);
    out(num_sections);
    out(present_area);
    out(percent_change);
    out(spacing);
    out(terrain_data_src_other);
    out(trans_power_output);
    out(mainkey);
    out(lat_whole_secs);
    out(lon_whole_secs);
    out(station_channel);
    out(lic_ant_make);
    out(lic_ant_model_num);
    out(min_horiz_erp);
    out(haat_horiz_calc_ind);
    out(erp_w);
    out(trans_power_output_w);
    out(market_group_num);
    out(last_change_date);
#undef out
    std::cout << '\n';
  }
};

